commit af6cf2a89cd0292a2783b7680f65b0425f6f9b22
Author: Your Name <you@example.com>
Date:   Tue Dec 2 09:12:51 2014 +0000

    backport query limiter to 3.1.7.2

diff --git a/pdns_recursor.cc b/pdns_recursor.cc
index fb9ce03..c5b1f87 100644
--- a/pdns_recursor.cc
+++ b/pdns_recursor.cc
@@ -540,7 +540,14 @@ void startDoResolve(void *p)
     int res;
 
     if(!g_pdl.get() || !g_pdl->preresolve(dc->d_remote, dc->d_mdp.d_qname, QType(dc->d_mdp.d_qtype), ret, res)) {
-       res = sr.beginResolve(dc->d_mdp.d_qname, QType(dc->d_mdp.d_qtype), dc->d_mdp.d_qclass, ret);
+      try {
+        res = sr.beginResolve(dc->d_mdp.d_qname, QType(dc->d_mdp.d_qtype), dc->d_mdp.d_qclass, ret);
+      }
+      catch(ImmediateServFailException &e) {
+        L<<Logger::Error<<"Sending SERVFAIL during resolve of '"<<dc->d_mdp.d_qname<<"' because: "<<e.reason<<endl;
+
+        res = RCode::ServFail;
+      }
 
        if(g_pdl.get()) {
 	 if(res == RCode::NXDomain)
diff --git a/syncres.cc b/syncres.cc
index 24dd4da..2fc605d 100644
--- a/syncres.cc
+++ b/syncres.cc
@@ -680,6 +680,7 @@ int SyncRes::doResolveAt(set<string, CIStringCompare> nameservers, string auth,
 	  }
 	  else {
 	    s_outqueries++; d_outqueries++;
+            if(d_outqueries > 50) throw ImmediateServFailException("more than 50 queries sent while resolving "+qname);
 	  TryTCP:
 	    if(doTCP) {
 	      LOG<<prefix<<qname<<": using TCP with "<< remoteIP->toStringWithPort() <<endl;
diff --git a/syncres.hh b/syncres.hh
index db9e16c..dd6bd49 100644
--- a/syncres.hh
+++ b/syncres.hh
@@ -513,6 +513,13 @@ replacing_insert(Index& i,const typename Index::value_type& x)
   return res;
 }
 
+class ImmediateServFailException
+{
+public:
+  ImmediateServFailException(string r){reason=r;};
+
+  string reason; //! Print this to tell the user what went wrong
+};
 
 std::string reloadAuthAndForwards();
 #endif
